#include <Application.h>
#include <Window.h>
#include <View.h>
#include <Region.h>


enum OP {
	CONSTRAIN,
	CLIP,
	NONE
};

class App : public BApplication {
public:
	App();
};

class Window : public BWindow {
public:
	Window();
};

class View : public BView {
public:
	View(BRect frame, bool, OP);
	void Draw(BRect);
	void _DrawRect(BRect);

public:
	bool fSetScale;
	OP fOp;
};

int main()
{
	App app;
	app.Run();
	return 0;
}

App::App()
	:BApplication("application/x-vnd.some-test-app")
{
	Window *window = new Window();
	window->Show();
}

Window::Window()
	:BWindow(BRect(100,100,200,200), "clipping test", B_TITLED_WINDOW, B_QUIT_ON_WINDOW_CLOSE)
{
	BView* b = new BView(Bounds(), "background", B_FOLLOW_ALL, 0);
	b->SetViewColor(128,128,128);
	AddChild(b);
	AddChild(new View(BRect(0,0,20,20), false, NONE));
	AddChild(new View(BRect(25,0,45,20), false, CONSTRAIN));
	AddChild(new View(BRect(50,0,70,20), false, CLIP));
	AddChild(new View(BRect(0,25,20,45), true, NONE));
	AddChild(new View(BRect(25,25,45,45), true, CONSTRAIN));
	AddChild(new View(BRect(50,25,70,45), true, CLIP));
}

View::View(BRect frame, bool setScale, OP op)
	:BView(frame, "", B_FOLLOW_NONE, B_WILL_DRAW)
	,fSetScale(setScale)
	,fOp(op)
{
}


void
View::_DrawRect(BRect r) {
	PushState();
	SetHighColor(255,0,0);
	FillRect(r);
	if (fOp != NONE) {
		if (fOp == CONSTRAIN) {
			BRegion region(r);
			ConstrainClippingRegion(&region);
		} else {
			//RotateBy(0.1);
			ClipToRect(r);
		}
		SetHighColor(0,0,255);
		FillRect(Bounds());
	}
	PopState();
}


void
View::Draw(BRect update)
{
	if (fSetScale)
		SetScale(3);
	else
		ScaleBy(3,3);
	_DrawRect(BRect(3,3,5,5));
	_DrawRect(BRect(1,1,1,1));
}
